leetcode 1 Two Sum Java & JavaScript解法

題目詳情

Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.

題目的意思是,輸入一個整數數組和一個目標和,讓咱們找整數數組中的兩個元素,使他們的加和恰好等於目標和。返回這兩個元素的位置。每一個輸入都有且僅有一組知足條件的元素。javascript

Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].java

想法

  • 若是使用蠻力法能夠簡單的解決這個問題。可是須要兩層循環,效率低。
  • 因此咱們新聲明一個hashmap用來存儲中間結果,使得只須要一趟遍歷就能夠完成查找。
  • HashMap remain用來存儲,每個元素和目標元素的差值和這個元素的位置。這樣的話,若是咱們後續遍歷到的元素恰好等於這個差值,就說明這兩個元素加和恰好等於目標和。
  • 因此對於每次遍歷到的元素num,先查找remain中有沒有key和num相等,若是有,則返回這兩個元素的位置,若是沒有,就把target-num的值和num的位置放入hashmap。

解法

public int[] twoSum(int[] nums, int target) {
        int[] res  = {-1,-1};
        HashMap<Integer,Integer> remain = new HashMap<Integer,Integer>();
        
        for(int i=0;i<nums.length;i++){
            if(remain.containsKey(nums[i])){
                res[0] = remain.get(nums[i]);
                res[1] = i;
                return res;
            }else{
                remain.put(target-nums[i], i);
            }
        }

        return res;
    }

javaScript篇

方法一

  • 蠻力法~兩層循環暴力解決~
var twoSum = function(nums, target) {
    var res = new Array; 
    for(let i=0;i<nums.length-1;i++){
        let temp = target - nums[i];
        for(let j = i+1;j<nums.length;j++){
            if(temp == nums[j]){
               res[0] = i;
               res[1] = j;
                return res;
               }
        }
    }
};

方法二

  • 由於javascript沒有hashmap這種數據結構,因此咱們這裏用對象來代替map。由於js裏的對象也是key-value鍵值對。
var twoSum = function(nums, target) {
var ans = [];
var exist = {};

for (var i = 0; i < nums.length; i++){
    if (typeof(exist[target-nums[i]]) !== 'undefined'){
        ans.push(exist[target-nums[i]]);
        ans.push(i);
    }
    exist[nums[i]] = i;
}

return ans;

};
相關文章
相關標籤/搜索